package
{
	import flash.display.*;
	import flash.events.*;
	import flash.data.*;
	import flash.filesystem.*;
	
	public class db extends MovieClip
	{
		static var DEFAULT_DB:String = "AIR_Sample";
		
		private var connectedDbs:uint = 0;
		private var dbsToConnect:uint = 0;
		private var conns:Object = new Object()
		private var conn:SQLConnection;
		private var dbStatement:SQLStatement;
		private var dbFile:File;
		private var queries:Array = new Array();
		private var queryRunning:Boolean = false;
		
		public function db ():void
		{
			connectDb(DEFAULT_DB);
			addEventListener(Event.ENTER_FRAME, frameHandler);
		}
		public function connectDb (db:String):void
		{
			dbsToConnect++;
			dbFile = File.documentsDirectory.resolvePath("AIR_Sample"+File.separator+"data"+File.separator+db+".db");
			dbFile.parent.parent.createDirectory();
			dbFile.parent.createDirectory();
			if (dbFile.exists)
			{
				//dbFile.deleteFile();
			}
			conn = new SQLConnection();
			conn.addEventListener(SQLEvent.OPEN, connOpenHandler);
			conn.addEventListener(SQLErrorEvent.ERROR, errorHandler);
			conn.openAsync(dbFile);
			conns[db] = conn;
		}
		private function connOpenHandler (event:SQLEvent):void
		{
			connectedDbs++;
		}
		public function Call (_params:Object):void
		{
			dbStatement = new SQLStatement();
			if (_params.db != null)
			{
				dbStatement.sqlConnection = conns[_params.db];
			} else
			{
				dbStatement.sqlConnection = conns[DEFAULT_DB];
			}
			dbStatement.addEventListener(SQLErrorEvent.ERROR, errorHandler);
			dbStatement.addEventListener(SQLEvent.RESULT, resultHandler);
			if (_params.datasetType != null)
			{
				dbStatement.itemClass = _params.datasetType;
			}
			dbStatement.text = _params.query;
			
			var dbCall:Object = new Object();
			dbCall.statement = dbStatement;
			dbCall.running = false;
			dbCall.datasetType = _params.datasetType;
			dbCall.query = dbStatement.text;
			dbCall.onComplete = _params.onComplete;
			
			queries.push(dbCall);
		}
		private function resultHandler (event:SQLEvent):void
		{
			var i:Number;
			var dbCall:Object;
			var result:SQLResult;
			var returnArray:Array;
			
			dbStatement = SQLStatement(event.target);
			for (i=0; i<queries.length && 10; i++)
			{
				if (queries[i].running == true && queries[i].query == dbStatement.text)
				{
					dbCall = queries[i];
					i = queries.length;
				}
			}
			if (dbStatement.text.toLowerCase().substr(0, 6) == "insert")
			{
				queryRunning = false;
				result = dbStatement.getResult();
				dbCall.onComplete(result.lastInsertRowID);
				return;
			} else
			if (dbStatement.text.toLowerCase().substr(0, 6) != "select")
			{
				queryRunning = false;
				dbCall.onComplete();
				return;
			}
			returnArray = new Array();
			result = dbStatement.getResult();
			if (result != null)
			{
				var numRows:int;
				try
				{
					numRows = result.data.length;
				} catch (e:Error)
				{
					numRows = 0;
				}
				for (i=0; i<numRows; i++)
				{
					returnArray.push(result.data[i]);
				}
			}
			dbCall.onComplete(returnArray);
			queryRunning = false;
		}
		private function errorHandler(event:SQLErrorEvent):void
		{
			queryRunning = false;
			myapp(this.parent).out(String(event.error));
		}
		private function frameHandler (event:Event):void
		{
			if (queryRunning || dbsToConnect > connectedDbs)
			{
				return;
			}
			var i:Number;
			var found:Boolean = false;
			var dbCall:Object;
			
			for (i=0; i<queries.length && i < 100; i++)
			{
				if (!queries[i].running)
				{
					dbCall = queries[i];
					found = true;
					i = queries.length;
				}
			}
			
			if (found)
			{
				queryRunning = true;
				dbCall.running = true;
				dbCall.statement.execute();
				dbCall.query = dbCall.statement.text;
			}
		}
	}
}